require 'rails/railtie'
require 'action_view/railtie'
require 'action_controller/railtie'

module Notifications
  def self.configure
    @configuration ||= Configuration.new

    yield @configuration if block_given?
  end

  def self.configuration
    @configuration
  end

  class Configuration
    attr_accessor :firebase_project_id, :firebase_api_key
  end

  configure
end

require 'notifications/version'
require 'notifications/uploader'
require 'notifications/engine'
require 'notifications/railtie'
require 'notifications/helper'
