module Notifications
  module Helper
    def notifications_for(destination, opts = {})
      opts = set_default_options(opts)

      content_tag opts[:container], '',
        id:    'js-notifications-container',
        class: opts[:container_class],
        data:  {
          firebase_project_id:          Notifications.configuration.firebase_project_id,
          firebase_api_key:             Notifications.configuration.firebase_api_key,
          destination:                  destination,
          notification_container:       opts[:notification_container],
          notification_container_class: opts[:notification_container_class],
          notification_class:           opts[:notification_class]
        }
    end

    def notifications_count_for(origin, opts = {})
      content_tag (opts[:container] || :div), '',
        id:    'js-notifications-count',
        class: opts[:container_class]
    end

    private

    def set_default_options(opts)
      opts[:container]                    ||= :div
      opts[:container_class]              ||= ''
      opts[:notification_container]       ||= :div
      opts[:notification_container_class] ||= ''
      opts[:notificaton_class]            ||= ''

      opts
    end
  end
end
